attribute vec4 attr_vertex, attr_color, attr_texcoord;
attribute vec4 attr_tangent;
attribute vec3 attr_normal;

uniform mat4 mvmat, projmat, texmat;
uniform mat3 normmat;
uniform float t;
uniform vec4 light_pos;

varying vec3 vpos, normal, tangent;
varying vec4 tc;
varying vec3 lpos;

void main()
{
	mat4 mvp = projmat * mvmat;
	gl_Position = mvp * attr_vertex;

	vpos = (mvmat * attr_vertex).xyz;

	normal = normmat * attr_normal;
	tangent = normmat * attr_tangent.xyz;

	lpos = (mvmat * light_pos).xyz;

	tc = texmat * attr_texcoord;
}
